#!/bin/sh

UBOOTIMG=/usr/local/share/u-boot/sg1100/flash-image.bin
FLASHDEV=/dev/flash/spi0

if [ ! -c ${FLASHDEV} -o ! -f ${UBOOTIMG} ]; then
	echo "Cannot update the SG-1100 U-boot.  Invalid settings."
	exit 1
fi

echo "=> Updating the SG-1100 U-boot"
echo "==> Reading current settings"
/usr/local/sbin/u-boot-env-read /tmp/ubenv 2> /dev/null
if [ ! -f /tmp/ubenv ]; then
	echo "==> Warning: No settings were found"
fi
echo "==> Updating the U-boot image (this may take a few minutes)"
/bin/dd if=${UBOOTIMG} of=${FLASHDEV} bs=64k
if [ -f /tmp/ubenv ]; then
	echo "==> Restoring settings"
	/usr/local/sbin/u-boot-env-write -yY /tmp/ubenv 2> /dev/null
	if [ $? -ne 0 ]; then
		echo "Failed to restore the settings, U-boot will not work properly."
		echo "Saving original settings in /root/ubenv for later recovery."
		cp /tmp/ubenv /root/ubenv
	fi
	/bin/rm /tmp/ubenv
fi
